#line 1 "C:/Users/katarina.perendic/Desktop/RiBUS_DSPIC/ribus_main.c"
#line 1 "c:/users/katarina.perendic/desktop/ribus_dspic/ribus_objects.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for dspic/packages/ft800/uses/ft800_types.h"
#line 21 "c:/users/public/documents/mikroelektronika/mikroc pro for dspic/packages/ft800/uses/ft800_types.h"
typedef unsigned char uint8_ft8;
typedef signed char int8_ft8;
typedef unsigned int uint16_ft8;
typedef int int16_ft8;
typedef unsigned long uint32_ft8;
typedef long int32_ft8;
typedef unsigned long long uint64_ft8;
typedef long long int64_ft8;

typedef enum {cmdREAD, cmdWRITE} TCmd;

typedef enum {opNONE, opREAD, opWRITE} TOpr;

typedef enum {umNONE, umDL=1<<0, umCP=1<<1, umGRAM=1<<2} TUpdateMode;

typedef enum {pfINTEGER, pf12P4=1<<0} TPixelFormat;

typedef enum {rndUP, rndDOWN, rndNEAREST} TRoundingType;

typedef enum {rtCurrRectCenter, rtRotCenter} TRotateType;

typedef uint8_ft8 TFT800Alpha;
typedef uint8_ft8 TFT800Handle;

typedef struct
{
 int16_ft8 X;
 int16_ft8 Y;
} TFT800Point;

typedef struct
{
 int16_ft8 Left;
 int16_ft8 Top;
 uint16_ft8 Width;
 uint16_ft8 Height;
} TFT800Rect;

typedef struct
{
 union
 {
 struct
 {
 TFT800Point P1, P2, P3, P4;
 };
 TFT800Point P[4];
 };
} TFT800Square;

typedef union
{
 struct
 {
 uint8_ft8 B;
 uint8_ft8 G;
 uint8_ft8 R;
 };
 uint32_ft8 RGB;
} TFT800Color;

typedef struct
{
 TFT800Color Color;
 TFT800Alpha Alpha;
 uint16_ft8 Width;
} TFT800Pen;

typedef struct
{
 TFT800Color ColorBg;
 TFT800Color Color;


 TFT800Color ColorTo;
 uint8_ft8 Gradient;
 TFT800Alpha Alpha;
 uint8_ft8 Style;
} TFT800Brush;




typedef struct
{

 uint8_ft8 FontWidth[ 256 ];
 uint32_ft8 FontBitmapFormat;
 uint32_ft8 FontLineStride;
 uint32_ft8 FontWidthInPixels;
 uint32_ft8 FontHeightInPixels;
 uint32_ft8 PointerToFontGraphicsData;
} TFT800FontGraphics;

typedef struct
{
 TFT800FontGraphics GrData;
 uint16_ft8 FirstChar;
 uint16_ft8 LastChar;
} TFT800CharSetDsc;

typedef struct
{
 uint32_ft8 Name;
 uint32_ft8 Source;
 TFT800Color Color;
 TFT800Alpha Alpha;
 TFT800Handle Handle;
 TFT800CharSetDsc CharSetDsc;
} TFT800Font;

typedef struct
{
 uint8_ft8 Format;
 uint16_ft8 LineStride;

 uint16_ft8 Height;
} TFT800BmpLayout;

typedef struct
{
 uint8_ft8 FwFlags;
 uint16_ft8 Width;
 uint16_ft8 Height;
} TFT800BmpSize;

typedef struct
{
 uint32_ft8 Source;
 TFT800BmpLayout Layout;
 TFT800BmpSize Size;
} TFT800BmpConfig;

typedef struct
{
 TFT800BmpConfig Configs[16];
 uint8_ft8 Current;
} TFT800BmpHandle;

typedef struct
{
 TFT800BmpConfig Config;
 TFT800Color BlendColor;
 TFT800Alpha Alpha;
 TFT800Handle Handle;
} TFT800Bitmap;

typedef struct
{
 uint16_ft8 Hour;
 uint16_ft8 Min;
 uint16_ft8 Sec;
 uint16_ft8 mSec;
} TFT800Time;

typedef struct
{
 uint32_ft8 DrawingOptions;
 uint16_ft8 Val;
 uint16_ft8 Size;
 uint16_ft8 Range;
 uint16_ft8 Minor;
 uint16_ft8 Major;
 TFT800Time Time;
 uint8_ft8 Style;
} TFT800CoProcGraphics;

typedef struct
{
 uint32_ft8 a;
 uint32_ft8 b;
 uint32_ft8 c;
 uint32_ft8 d;
 uint32_ft8 e;
 uint32_ft8 f;
} TFT800TransformMatrix;

typedef struct
{
 TRotateType Type;
 uint8_ft8 RotateFont;
 int16_ft8 Angle;
 TFT800Point Center;
} TFT800Rotate;

typedef struct
{
 TFT800Pen Pen;
 TFT800Brush Brush;
 TFT800Font Font;
 TFT800Bitmap Bitmap;

 TFT800Rect ClipRect;
 TFT800Rect CurrRect;
 TFT800Point Cursor;

 uint8_ft8 RotateFont;

 uint8_ft8 Stencil;
 uint8_ft8 Tag;

 TRoundingType RoundingType;
 TPixelFormat PixelFormat;

 TFT800CoProcGraphics CPGraphics;
} TFT800Canvas;

typedef struct
{
 TOpr Opr;
 uint32_ft8 RWPtr;
} TFT800IO;

typedef struct
{
 uint32_ft8 Reset;
 uint32_ft8 ReadPtr;
 uint32_ft8 WritePtr;
 uint32_ft8 DlPtr;
} TFT800CoProc;


typedef struct
{

 uint32_ft8 Frequency;
 uint32_ft8 OutRenderMode;
 uint32_ft8 RenderReadScanLine;
 uint32_ft8 RenderWriteTrigger;
 uint32_ft8 hCycle;
 uint32_ft8 hOffset;
 uint32_ft8 hSize;
 uint32_ft8 hSync0;
 uint32_ft8 hSync1;
 uint32_ft8 vCycle;
 uint32_ft8 vOffset;
 uint32_ft8 vSize;
 uint32_ft8 vSync0;
 uint32_ft8 vSync1;
 uint32_ft8 Rotate180;
 uint32_ft8 OutBits;
 uint32_ft8 OutDither;
 uint32_ft8 OutSwizzle;
 uint32_ft8 OutCSpread;
 uint32_ft8 PClockPolarity;
 uint32_ft8 PClock;
} TFT800Display;

typedef struct
{
 uint32_ft8 TouchMode;
 uint32_ft8 TouchADCMode;
 uint32_ft8 TouchCharge;
 uint32_ft8 TouchSettle;
 uint32_ft8 TouchOversample;
 uint32_ft8 TouchRZThreshold;
} TFT800Touch;

typedef struct
{
 uint32_ft8 TransformA;
 uint32_ft8 TransformB;
 uint32_ft8 TransformC;
 uint32_ft8 TransformD;
 uint32_ft8 TransformE;
 uint32_ft8 TransformF;
} TFT800TouchTransform;

typedef struct
{
 uint32_ft8 Flags;
 uint32_ft8 Enable;
 uint32_ft8 Mask;
} TFT800Interrupt;

typedef struct
{
 uint32_ft8 Volume;
 struct
 {
 uint8_ft8 Effect;
 uint8_ft8 Pitch;
 :16;
 };
 uint32_ft8 Play;
} TFT800Sound;

typedef struct
{
 uint32_ft8 Volume;
 uint32_ft8 StartAddress;
 uint32_ft8 Length;
 uint32_ft8 ReadPtr;
 uint32_ft8 Frequency;
 uint32_ft8 Format;
 uint32_ft8 Loop;
 uint32_ft8 Play;
} TFT800Audio;

typedef struct
{

 uint32_ft8 Freq;
 uint32_ft8 Duty;
} TFT800PWM;

typedef struct
{
 uint32_ft8 GPIODIR;
 uint32_ft8 GPIO;
} TFT800GPIO;

typedef struct
{
 TFT800PWM *pPWMCfg;
 TFT800GPIO *pGPIOCfg;
 TFT800Audio *pAudioCfg;
 TFT800Sound *pSoundCfg;
 TFT800Touch *pTouchCfg;
 TFT800Display *pDisplayCfg;
 TFT800Interrupt *pInterruptCfg;
 TFT800TouchTransform *pTTransformCfg;
} TFT800Config;




typedef struct
{




 TFT800Color Color;
 TFT800Alpha Alpha;

 uint8_ft8 Tag;

 TFT800Color ClearColor;
 TFT800Alpha ClearAlpha;
 uint8_ft8 ClearStencil;
 uint8_ft8 ClearTag;

 uint16_ft8 LineWidth;
 uint16_ft8 PointSize;

 uint16_ft8 ScissorLeft;
 uint16_ft8 ScissorTop;
 uint16_ft8 ScissorWidth;
 uint16_ft8 ScissorHeight;

 uint8_ft8 BmpHandle;
 uint8_ft8 Cell;

} TFT800GrContext;

typedef struct
{
 TFT800GrContext *Context;
 uint8_ft8 MaxDepth;
} TFT800GrContextStack;

typedef struct
{
 TFT800GrContext Context;

 TFT800GrContextStack *pUserGrContextStack;
 uint8_ft8 CurrGrContextDepth;

 struct
 {
 Color : 1;
 Alpha : 1;
 Tag : 1;
 ClearColor : 1;
 ClearAlpha : 1;
 ClearStencil : 1;
 ClearTag : 1;
 LineWidth : 1;
 PointSize : 1;
 ScissorPos : 1;
 ScissorSize : 1;
 BmpHandle : 1;
 Cell : 1;

 Unused : 32-13;

 } UpdateContextFlags;



 TFT800BmpConfig BmpHandleCfg[16];

 int8_ft8 CurrGrPrim;
} TFT800Graphics;

typedef struct
{
 TFT800IO IO;





 TFT800Graphics Graphics;

 struct
 {
 uint16_ft8 Width;
 uint16_ft8 Height;
 } Display;

 struct
 { uint16_ft8 ID;
 uint16_ft8 Rev;
 } ChipInfo;

 uint8_ft8 UpdateMode;

} TFT800Controller;
#line 6 "c:/users/katarina.perendic/desktop/ribus_dspic/ribus_objects.h"
typedef enum {taNone, taLeft, taCenter, taRight, taCenterX, taCenterY, taRightX} TTextAlign;

typedef struct Screen TScreen;

typedef unsigned long TPointer;

typedef struct tagObjInfo {
 void *Obj;
 char Type;
 char Order;
 char Flags;

 char HitTag;
 int HitX;
 int HitY;
} TObjInfo;

typedef struct tagTouchStat {
 char Pressed;

 char Tag;
 int X;
 int Y;

 TObjInfo ActObjInfo;
} TTouchStat;

typedef void (*TDrawHandler)(TPointer aObj);

typedef void (*TEvtAction)();

typedef struct tagEvtSound {
 char SndAct;
 char Effect;
 char Pitch;
 char Volume;
} TEvtSound;

typedef const far struct tagCEvent {
 TEvtAction Action;
 TEvtSound Sound;
} TCEvent;

typedef struct tagEvent {
 TEvtAction Action;
 TEvtSound Sound;
} TEvent;

typedef const far struct tagCRect {
 int Left;
 int Top;
 int Width;
 int Height;
} TCRect;

typedef struct tagRect {
 int Left;
 int Top;
 int Width;
 int Height;
} TRect;

typedef struct tagEveText {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Width;
 int Height;
 char *Caption;
 TTextAlign TextAlign;
 far const code char *FontName;
 unsigned int Font_Color;
 char FontHandle;
 long Source;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TEveText;

typedef struct tagEveNumber {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Width;
 int Height;
 char Text_Length;
 TTextAlign TextAlign;
 far const code char *FontName;
 unsigned int Font_Color;
 char FontHandle;
 long Source;
 signed long Value;
 unsigned char Signed;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TEveNumber;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned short EveTextsCount;
 TEveText *far const code *EveTexts;
 unsigned short EveNumbersCount;
 TEveNumber *far const code *EveNumbers;
 unsigned long DynResStart;
 unsigned short Active;
 unsigned short SniffObjectEvents;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnTagChange;
 TEvent *OnPress;
};




extern const VTFT_OT_EVETEXT;
extern const VTFT_OT_EVENUMBER;




extern const VTFT_EVT_UP;
extern const VTFT_EVT_DOWN;
extern const VTFT_EVT_CLICK;
extern const VTFT_EVT_PRESS;




extern const VTFT_SNDACT_NONE;
extern const VTFT_SNDACT_PLAY;
extern const VTFT_SNDACT_STOP;




extern const VTFT_LOAD_RES_NONE;
extern const VTFT_LOAD_RES_STATIC;
extern const VTFT_LOAD_RES_DYNAMIC;
extern const VTFT_LOAD_RES_ALL;




extern const VTFT_DISPLAY_EFF_NONE;
extern const VTFT_DISPLAY_EFF_LIGHTS_FADE;
extern const VTFT_DISPLAY_EFF_LIGHTS_OFF;




extern const VTFT_INT_REPAINT_ON_DOWN;
extern const VTFT_INT_REPAINT_ON_UP;
extern const VTFT_INT_BRING_TO_FRONT;
extern const VTFT_INT_INTRINSIC_CLICK_EFF;




extern const TPointer DrawHandlerTable[44];




extern const TFT800PWM VTFT_FT800_CONFIG_PWM;
extern const TFT800GPIO VTFT_FT800_CONFIG_GPIO;
extern const TFT800Sound VTFT_FT800_CONFIG_SOUND;
extern const TFT800Audio VTFT_FT800_CONFIG_AUDIO;
extern const TFT800Display VTFT_FT800_CONFIG_DISPLAY;
extern const TFT800Interrupt VTFT_FT800_CONFIG_INTERRUPT;
extern const TFT800Touch VTFT_FT800_CONFIG_TOUCH;
extern const TFT800TouchTransform VTFT_FT800_CONFIG_TOUCHTRANSFORM;

extern TTouchStat TouchS;

extern TScreen Screen1;

extern TEveText EveText1;
extern TEveNumber EveNumber1;

extern TEveText *far const code Screen1_EveTexts[1];
extern TEveNumber *far const code Screen1_EveNumbers[1];

extern TScreen *CurrentScreen;







extern char EveText1_Caption[];

void DrawScreenO(TScreen *aScreen, char aOptions);
void DrawScreen(TScreen *aScreen);
void DrawEveText(TEveText *AEveText);
void DrawEveNumber(TEveNumber *AEveNumber);
void ProcessVTFTStack();
void InitVTFTStack();
#line 19 "C:/Users/katarina.perendic/Desktop/RiBUS_DSPIC/ribus_main.c"
int cnt = 0;

void main() {

 InitVTFTStack();

 while(cnt < 1000)
 {
 EveNumber1.Value = cnt;
 DrawEveNumber(&EveNumber1);
 DrawScreen(&Screen1);
 cnt++;
 Delay_ms(300);
 }

}
