' Text alignment
' Usage: internally used by VTFT stack
const taNone    as TTextAlign external
const taLeft    as TTextAlign external
const taCenter  as TTextAlign external
const taRight   as TTextAlign external
const taCenterX as TTextAlign external
const taCenterY as TTextAlign external
const taRightX  as TTextAlign external
' ~Text alignment

' Object type constants
' Usage: VTFT stack internally
const VTFT_OT_EVETEXT as byte external
const VTFT_OT_EVENUMBER as byte external
' ~Object type constants

' Event type constants
' Usage: OnEvent
const VTFT_EVT_UP    as byte external
const VTFT_EVT_DOWN  as byte external
const VTFT_EVT_CLICK as byte external
const VTFT_EVT_PRESS as byte external
' ~Event type constants

' Sound action constants
' Usage: sound event action property and ProcessEvent
const VTFT_SNDACT_NONE as byte external
const VTFT_SNDACT_PLAY as byte external
const VTFT_SNDACT_STOP as byte external
' ~Sound action constants

' Resource loading constants.
' Usage: DrawScreenO and LoadCurrentScreenResToGRAM
const VTFT_LOAD_RES_NONE    as byte external
const VTFT_LOAD_RES_STATIC  as byte external
const VTFT_LOAD_RES_DYNAMIC as byte external
const VTFT_LOAD_RES_ALL     as byte external
' ~Resource loading constants

' Display effect constants
' Usage: DrawScreenO
const VTFT_DISPLAY_EFF_NONE        as byte external
const VTFT_DISPLAY_EFF_LIGHTS_FADE as byte external
const VTFT_DISPLAY_EFF_LIGHTS_OFF  as byte external
' ~Display effect constants

' Stack flags
' Usage: internally used by VTFT stack
const VTFT_INT_REPAINT_ON_DOWN     as byte external
const VTFT_INT_REPAINT_ON_UP       as byte external
const VTFT_INT_BRING_TO_FRONT      as byte external
const VTFT_INT_INTRINSIC_CLICK_EFF as byte external
' ~Stack flags

' Default configuration parameters
const  VTFT_FT800_CONFIG_PWM as TFT800PWM external
const  VTFT_FT800_CONFIG_GPIO as TFT800GPIO external
const  VTFT_FT800_CONFIG_SOUND as TFT800Sound external
const  VTFT_FT800_CONFIG_AUDIO as TFT800Audio external
const  VTFT_FT800_CONFIG_DISPLAY as TFT800Display external
const  VTFT_FT800_CONFIG_INTERRUPT as TFT800Interrupt external
const VTFT_FT800_CONFIG_TOUCH as TFT800Touch external
const  VTFT_FT800_CONFIG_TOUCHTRANSFORM as TFT800TouchTransform external


dim CurrentScreen as TScreenPtr external
dim TouchS as TTouchStat external

' Routine declarations
sub procedure DrawScreenO(dim aScreen as TScreenPtr, dim aOptions as byte) external
sub procedure DrawScreen(dim aScreen as TScreenPtr) external
sub procedure DrawEveText(dim AEveText as TEveTextPtr) external
sub procedure DrawEveNumber(dim AEveNumber as TEveNumberPtr) external
sub procedure ProcessVTFTStack() external
sub procedure InitVTFTStack() external
' ~Routine declarations

