#line 1 "D:/Clicks_git/R/RiBUS_click/SW/Example/c/RiBUS_PIC/ribus_driver.c"
#line 1 "d:/clicks_git/r/ribus_click/sw/example/c/ribus_pic/ribus_objects.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/packages/ft800/uses/ft800_types.h"
#line 21 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/packages/ft800/uses/ft800_types.h"
typedef unsigned char uint8_ft8;
typedef signed char int8_ft8;
typedef unsigned int uint16_ft8;
typedef int int16_ft8;
typedef unsigned long uint32_ft8;
typedef long int32_ft8;
typedef unsigned long long uint64_ft8;
typedef long long int64_ft8;

typedef enum {cmdREAD, cmdWRITE} TCmd;

typedef enum {opNONE, opREAD, opWRITE} TOpr;

typedef enum {umNONE, umDL=1<<0, umCP=1<<1, umGRAM=1<<2} TUpdateMode;

typedef enum {pfINTEGER, pf12P4=1<<0} TPixelFormat;

typedef enum {rndUP, rndDOWN, rndNEAREST} TRoundingType;

typedef enum {rtCurrRectCenter, rtRotCenter} TRotateType;

typedef uint8_ft8 TFT800Alpha;
typedef uint8_ft8 TFT800Handle;

typedef struct
{
 int16_ft8 X;
 int16_ft8 Y;
} TFT800Point;

typedef struct
{
 int16_ft8 Left;
 int16_ft8 Top;
 uint16_ft8 Width;
 uint16_ft8 Height;
} TFT800Rect;

typedef struct
{
 union
 {
 struct
 {
 TFT800Point P1, P2, P3, P4;
 };
 TFT800Point P[4];
 };
} TFT800Square;

typedef union
{
 struct
 {
 uint8_ft8 B;
 uint8_ft8 G;
 uint8_ft8 R;
 };
 uint32_ft8 RGB;
} TFT800Color;

typedef struct
{
 TFT800Color Color;
 TFT800Alpha Alpha;
 uint16_ft8 Width;
} TFT800Pen;

typedef struct
{
 TFT800Color ColorBg;
 TFT800Color Color;


 TFT800Color ColorTo;
 uint8_ft8 Gradient;
 TFT800Alpha Alpha;
 uint8_ft8 Style;
} TFT800Brush;




typedef struct
{

 uint8_ft8 FontWidth[ 256 ];
 uint32_ft8 FontBitmapFormat;
 uint32_ft8 FontLineStride;
 uint32_ft8 FontWidthInPixels;
 uint32_ft8 FontHeightInPixels;
 uint32_ft8 PointerToFontGraphicsData;
} TFT800FontGraphics;

typedef struct
{
 TFT800FontGraphics GrData;
 uint16_ft8 FirstChar;
 uint16_ft8 LastChar;
} TFT800CharSetDsc;

typedef struct
{
 uint32_ft8 Name;
 uint32_ft8 Source;
 TFT800Color Color;
 TFT800Alpha Alpha;
 TFT800Handle Handle;
 TFT800CharSetDsc CharSetDsc;
} TFT800Font;

typedef struct
{
 uint8_ft8 Format;
 uint16_ft8 LineStride;

 uint16_ft8 Height;
} TFT800BmpLayout;

typedef struct
{
 uint8_ft8 FwFlags;
 uint16_ft8 Width;
 uint16_ft8 Height;
} TFT800BmpSize;

typedef struct
{
 uint32_ft8 Source;
 TFT800BmpLayout Layout;
 TFT800BmpSize Size;
} TFT800BmpConfig;

typedef struct
{
 TFT800BmpConfig Configs[16];
 uint8_ft8 Current;
} TFT800BmpHandle;

typedef struct
{
 TFT800BmpConfig Config;
 TFT800Color BlendColor;
 TFT800Alpha Alpha;
 TFT800Handle Handle;
} TFT800Bitmap;

typedef struct
{
 uint16_ft8 Hour;
 uint16_ft8 Min;
 uint16_ft8 Sec;
 uint16_ft8 mSec;
} TFT800Time;

typedef struct
{
 uint32_ft8 DrawingOptions;
 uint16_ft8 Val;
 uint16_ft8 Size;
 uint16_ft8 Range;
 uint16_ft8 Minor;
 uint16_ft8 Major;
 TFT800Time Time;
 uint8_ft8 Style;
} TFT800CoProcGraphics;

typedef struct
{
 uint32_ft8 a;
 uint32_ft8 b;
 uint32_ft8 c;
 uint32_ft8 d;
 uint32_ft8 e;
 uint32_ft8 f;
} TFT800TransformMatrix;

typedef struct
{
 TRotateType Type;
 uint8_ft8 RotateFont;
 int16_ft8 Angle;
 TFT800Point Center;
} TFT800Rotate;

typedef struct
{
 TFT800Pen Pen;
 TFT800Brush Brush;
 TFT800Font Font;
 TFT800Bitmap Bitmap;

 TFT800Rect ClipRect;
 TFT800Rect CurrRect;
 TFT800Point Cursor;

 uint8_ft8 RotateFont;

 uint8_ft8 Stencil;
 uint8_ft8 Tag;

 TRoundingType RoundingType;
 TPixelFormat PixelFormat;

 TFT800CoProcGraphics CPGraphics;
} TFT800Canvas;

typedef struct
{
 TOpr Opr;
 uint32_ft8 RWPtr;
} TFT800IO;

typedef struct
{
 uint32_ft8 Reset;
 uint32_ft8 ReadPtr;
 uint32_ft8 WritePtr;
 uint32_ft8 DlPtr;
} TFT800CoProc;


typedef struct
{

 uint32_ft8 Frequency;
 uint32_ft8 OutRenderMode;
 uint32_ft8 RenderReadScanLine;
 uint32_ft8 RenderWriteTrigger;
 uint32_ft8 hCycle;
 uint32_ft8 hOffset;
 uint32_ft8 hSize;
 uint32_ft8 hSync0;
 uint32_ft8 hSync1;
 uint32_ft8 vCycle;
 uint32_ft8 vOffset;
 uint32_ft8 vSize;
 uint32_ft8 vSync0;
 uint32_ft8 vSync1;
 uint32_ft8 Rotate180;
 uint32_ft8 OutBits;
 uint32_ft8 OutDither;
 uint32_ft8 OutSwizzle;
 uint32_ft8 OutCSpread;
 uint32_ft8 PClockPolarity;
 uint32_ft8 PClock;
} TFT800Display;

typedef struct
{
 uint32_ft8 TouchMode;
 uint32_ft8 TouchADCMode;
 uint32_ft8 TouchCharge;
 uint32_ft8 TouchSettle;
 uint32_ft8 TouchOversample;
 uint32_ft8 TouchRZThreshold;
} TFT800Touch;

typedef struct
{
 uint32_ft8 TransformA;
 uint32_ft8 TransformB;
 uint32_ft8 TransformC;
 uint32_ft8 TransformD;
 uint32_ft8 TransformE;
 uint32_ft8 TransformF;
} TFT800TouchTransform;

typedef struct
{
 uint32_ft8 Flags;
 uint32_ft8 Enable;
 uint32_ft8 Mask;
} TFT800Interrupt;

typedef struct
{
 uint32_ft8 Volume;
 struct
 {
 uint8_ft8 Effect;
 uint8_ft8 Pitch;
 :16;
 };
 uint32_ft8 Play;
} TFT800Sound;

typedef struct
{
 uint32_ft8 Volume;
 uint32_ft8 StartAddress;
 uint32_ft8 Length;
 uint32_ft8 ReadPtr;
 uint32_ft8 Frequency;
 uint32_ft8 Format;
 uint32_ft8 Loop;
 uint32_ft8 Play;
} TFT800Audio;

typedef struct
{

 uint32_ft8 Freq;
 uint32_ft8 Duty;
} TFT800PWM;

typedef struct
{
 uint32_ft8 GPIODIR;
 uint32_ft8 GPIO;
} TFT800GPIO;

typedef struct
{
 TFT800PWM *pPWMCfg;
 TFT800GPIO *pGPIOCfg;
 TFT800Audio *pAudioCfg;
 TFT800Sound *pSoundCfg;
 TFT800Touch *pTouchCfg;
 TFT800Display *pDisplayCfg;
 TFT800Interrupt *pInterruptCfg;
 TFT800TouchTransform *pTTransformCfg;
} TFT800Config;




typedef struct
{




 TFT800Color Color;
 TFT800Alpha Alpha;

 uint8_ft8 Tag;

 TFT800Color ClearColor;
 TFT800Alpha ClearAlpha;
 uint8_ft8 ClearStencil;
 uint8_ft8 ClearTag;

 uint16_ft8 LineWidth;
 uint16_ft8 PointSize;

 uint16_ft8 ScissorLeft;
 uint16_ft8 ScissorTop;
 uint16_ft8 ScissorWidth;
 uint16_ft8 ScissorHeight;

 uint8_ft8 BmpHandle;
 uint8_ft8 Cell;

} TFT800GrContext;

typedef struct
{
 TFT800GrContext *Context;
 uint8_ft8 MaxDepth;
} TFT800GrContextStack;

typedef struct
{
 TFT800GrContext Context;

 TFT800GrContextStack *pUserGrContextStack;
 uint8_ft8 CurrGrContextDepth;

 struct
 {
 Color : 1;
 Alpha : 1;
 Tag : 1;
 ClearColor : 1;
 ClearAlpha : 1;
 ClearStencil : 1;
 ClearTag : 1;
 LineWidth : 1;
 PointSize : 1;
 ScissorPos : 1;
 ScissorSize : 1;
 BmpHandle : 1;
 Cell : 1;

 Unused : 32-13;

 } UpdateContextFlags;



 TFT800BmpConfig BmpHandleCfg[16];

 int8_ft8 CurrGrPrim;
} TFT800Graphics;

typedef struct
{
 TFT800IO IO;





 TFT800Graphics Graphics;

 struct
 {
 uint16_ft8 Width;
 uint16_ft8 Height;
 } Display;

 struct
 { uint16_ft8 ID;
 uint16_ft8 Rev;
 } ChipInfo;

 uint8_ft8 UpdateMode;

} TFT800Controller;
#line 6 "d:/clicks_git/r/ribus_click/sw/example/c/ribus_pic/ribus_objects.h"
typedef enum {taNone, taLeft, taCenter, taRight, taCenterX, taCenterY, taRightX} TTextAlign;

typedef struct Screen TScreen;

typedef unsigned long TPointer;

typedef struct tagObjInfo {
 void *Obj;
 char Type;
 char Order;
 char Flags;

 char HitTag;
 int HitX;
 int HitY;
} TObjInfo;

typedef struct tagTouchStat {
 char Pressed;

 char Tag;
 int X;
 int Y;

 TObjInfo ActObjInfo;
} TTouchStat;

typedef void (*TDrawHandler)(TPointer aObj);

typedef void (*TEvtAction)();

typedef struct tagEvtSound {
 char SndAct;
 char Effect;
 char Pitch;
 char Volume;
} TEvtSound;

typedef const struct tagCEvent {
 TEvtAction Action;
 TEvtSound Sound;
} TCEvent;

typedef struct tagEvent {
 TEvtAction Action;
 TEvtSound Sound;
} TEvent;

typedef const struct tagCRect {
 int Left;
 int Top;
 int Width;
 int Height;
} TCRect;

typedef struct tagRect {
 int Left;
 int Top;
 int Width;
 int Height;
} TRect;

typedef struct tagEveText {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Width;
 int Height;
 char *Caption;
 TTextAlign TextAlign;
 const code char *FontName;
 unsigned int Font_Color;
 char FontHandle;
 long Source;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TEveText;

typedef struct tagEveNumber {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Width;
 int Height;
 char Text_Length;
 TTextAlign TextAlign;
 const code char *FontName;
 unsigned int Font_Color;
 char FontHandle;
 long Source;
 signed long Value;
 unsigned char Signed;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TEveNumber;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned short EveTextsCount;
 TEveText *const code *EveTexts;
 unsigned short EveNumbersCount;
 TEveNumber *const code *EveNumbers;
 unsigned long DynResStart;
 unsigned short Active;
 unsigned short SniffObjectEvents;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnTagChange;
 TEvent *OnPress;
};




extern const VTFT_OT_EVETEXT;
extern const VTFT_OT_EVENUMBER;




extern const VTFT_EVT_UP;
extern const VTFT_EVT_DOWN;
extern const VTFT_EVT_CLICK;
extern const VTFT_EVT_PRESS;




extern const VTFT_SNDACT_NONE;
extern const VTFT_SNDACT_PLAY;
extern const VTFT_SNDACT_STOP;




extern const VTFT_LOAD_RES_NONE;
extern const VTFT_LOAD_RES_STATIC;
extern const VTFT_LOAD_RES_DYNAMIC;
extern const VTFT_LOAD_RES_ALL;




extern const VTFT_DISPLAY_EFF_NONE;
extern const VTFT_DISPLAY_EFF_LIGHTS_FADE;
extern const VTFT_DISPLAY_EFF_LIGHTS_OFF;




extern const VTFT_INT_REPAINT_ON_DOWN;
extern const VTFT_INT_REPAINT_ON_UP;
extern const VTFT_INT_BRING_TO_FRONT;
extern const VTFT_INT_INTRINSIC_CLICK_EFF;




extern const TPointer DrawHandlerTable[44];




extern const TFT800PWM VTFT_FT800_CONFIG_PWM;
extern const TFT800GPIO VTFT_FT800_CONFIG_GPIO;
extern const TFT800Sound VTFT_FT800_CONFIG_SOUND;
extern const TFT800Audio VTFT_FT800_CONFIG_AUDIO;
extern const TFT800Display VTFT_FT800_CONFIG_DISPLAY;
extern const TFT800Interrupt VTFT_FT800_CONFIG_INTERRUPT;
extern const TFT800Touch VTFT_FT800_CONFIG_TOUCH;
extern const TFT800TouchTransform VTFT_FT800_CONFIG_TOUCHTRANSFORM;

extern TTouchStat TouchS;

extern TScreen Screen1;

extern TEveText EveText1;
extern TEveNumber EveNumber1;

extern TEveText *const code Screen1_EveTexts[1];
extern TEveNumber *const code Screen1_EveNumbers[1];

extern TScreen *CurrentScreen;







extern char EveText1_Caption[];

void DrawScreenO(TScreen *aScreen, char aOptions);
void DrawScreen(TScreen *aScreen);
void DrawEveText(TEveText *AEveText);
void DrawEveNumber(TEveNumber *AEveNumber);
void ProcessVTFTStack();
void InitVTFTStack();
#line 1 "d:/clicks_git/r/ribus_click/sw/example/c/ribus_pic/ribus_resources.h"



const code char Tahoma_48x48_BoldItalic[];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/packages/ft800/uses/ft800_types.h"
#line 8 "D:/Clicks_git/R/RiBUS_click/SW/Example/c/RiBUS_PIC/ribus_driver.c"
sbit FT800_RST at LATC0_bit;
sbit FT800_CS at LATE0_bit;
sbit FT800_RST_Direction at TRISC0_bit;
sbit FT800_CS_Direction at TRISE0_bit;




const VTFT_OT_EVETEXT = 40;
const VTFT_OT_EVENUMBER = 42;




const VTFT_EVT_UP = 0;
const VTFT_EVT_DOWN = 1;
const VTFT_EVT_CLICK = 2;
const VTFT_EVT_PRESS = 3;




const VTFT_SNDACT_NONE = 0;
const VTFT_SNDACT_PLAY = 1;
const VTFT_SNDACT_STOP = 2;




const VTFT_LOAD_RES_NONE = 0x00;
const VTFT_LOAD_RES_STATIC = 0x01;
const VTFT_LOAD_RES_DYNAMIC = 0x02;
const VTFT_LOAD_RES_ALL = 0x03;




const VTFT_DISPLAY_EFF_NONE = 0x00;
const VTFT_DISPLAY_EFF_LIGHTS_FADE = 0x04;
const VTFT_DISPLAY_EFF_LIGHTS_OFF = 0x08;




const VTFT_INT_REPAINT_ON_DOWN = 1 << 0;
const VTFT_INT_REPAINT_ON_UP = 1 << 1;
const VTFT_INT_BRING_TO_FRONT = 1 << 2;
const VTFT_INT_INTRINSIC_CLICK_EFF = 1 << 3;




const TPointer DrawHandlerTable[44] = {
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 &DrawEveText,
 0,
 &DrawEveNumber,
 0
};




const TFT800Display VTFT_FT800_CONFIG_DISPLAY =
{
 48000000,
 0,
 0,
 0,
 525,
 43,
 480,
 0,
 41,
 286,
 12,
 272,
 0,
 10,
 0,
 0x01B6,
 0,
 0x0000,
 0,
 1,
 5,
};

const TFT800Touch VTFT_FT800_CONFIG_TOUCH =
{
 3,
 1,
 6000,
 3,
 7,
 2000,
};

const TFT800TouchTransform VTFT_FT800_CONFIG_TOUCHTRANSFORM =
{
 0x00007DC4,
 0x00000310,
 0xFFF0E6CE,
 0x000001B1,
 0x00004B21,
 0xFFF0CB0A,
};

const TFT800GPIO VTFT_FT800_CONFIG_GPIO =
{
 0xFC,
 0xFF,
};

const TFT800PWM VTFT_FT800_CONFIG_PWM =
{
 255,
 127,
};

const TFT800Interrupt VTFT_FT800_CONFIG_INTERRUPT =
{
 0,
 0,
 255,
};

const TFT800Sound VTFT_FT800_CONFIG_SOUND =
{
 0,
 {0,
 0},
 0,
};

const TFT800Audio VTFT_FT800_CONFIG_AUDIO =
{
 0,
 0,
 0,
 0,
 8000,
 0,
 0,
 0,
};



TTouchStat TouchS = {0};



TScreen *CurrentScreen = 0;


TScreen Screen1;

TEveText EveText1;
char EveText1_Caption[8] = "COUNTER";
TEveNumber EveNumber1;

TEveText *const code Screen1_EveTexts[1] = {
 &EveText1
};

TEveNumber *const code Screen1_EveNumbers[1] = {
 &EveNumber1
};


static char IsInsideObject(TObjInfo *AObjInfo, unsigned int X, unsigned int Y) {
 TRect *ptrPressRect = 0;
 TRect *ptrPressCircle = 0;

 if ((AObjInfo->HitX == X) && (AObjInfo->HitY == Y))
 return 1;

 switch (AObjInfo->Type) {

 case VTFT_OT_EVETEXT: {
 ptrPressRect = (TRect *)&(((TEveText *)AObjInfo->Obj)->Left);
 break;
 }

 case VTFT_OT_EVENUMBER: {
 ptrPressRect = (TRect *)&(((TEveNumber *)AObjInfo->Obj)->Left);
 break;
 }
 }

 if (ptrPressRect) {
 if ((ptrPressRect->Left <= X) && (ptrPressRect->Left+ptrPressRect->Width-1 >= X) &&
 (ptrPressRect->Top <= Y) && (ptrPressRect->Top+ptrPressRect->Height-1 >= Y))
 return 1;
 }
 else if (ptrPressCircle) {
 if ((ptrPressCircle->Left <= X) && (ptrPressCircle->Left+ptrPressCircle->Width*2-1 >= X) &&
 (ptrPressCircle->Top <= Y) && (ptrPressCircle->Top+ptrPressCircle->Width*2-1 >= Y))
 return 1;
 }

 return 0;
}

void DrawEveText(TEveText *AEveText) {
 unsigned long drawOptions;

 if (AEveText->Visible) {
 if (AEveText->FontHandle >= 16)
 FT800_Canvas_FontSystem(AEveText->FontHandle, AEveText->Font_Color, AEveText->Opacity);
 else
 FT800_Canvas_Font(AEveText->FontHandle, AEveText->FontName, AEveText->Source, AEveText->Font_Color, AEveText->Opacity);

 if (AEveText->Tag)
 FT800_Canvas_Tag(AEveText->Tag);

 drawOptions = 0;
 if (AEveText->TextAlign == taCenter)
 drawOptions |= _FT800_CP_DRAW_OPT_CENTER;
 else if (AEveText->TextAlign == taCenterX)
 drawOptions |= _FT800_CP_DRAW_OPT_CENTERX;
 else if (AEveText->TextAlign == taCenterY)
 drawOptions |= _FT800_CP_DRAW_OPT_CENTERY;
 else if (AEveText->TextAlign == taRightX)
 drawOptions |= _FT800_CP_DRAW_OPT_RIGHTX;
 FT800_Canvas_CPGraphics_DrawingOptions(drawOptions);

 FT800_Screen_TextCP(AEveText->Left, AEveText->Top, AEveText->Caption);
 }
}

void DrawEveNumber(TEveNumber *AEveNumber) {
 unsigned long drawOptions;

 if (AEveNumber->Visible) {
 if (AEveNumber->FontHandle >= 16)
 FT800_Canvas_FontSystem(AEveNumber->FontHandle, AEveNumber->Font_Color, AEveNumber->Opacity);
 else
 FT800_Canvas_Font(AEveNumber->FontHandle, AEveNumber->FontName, AEveNumber->Source, AEveNumber->Font_Color, AEveNumber->Opacity);

 if (AEveNumber->Tag)
 FT800_Canvas_Tag(AEveNumber->Tag);

 drawOptions = 0;
 if (AEveNumber->TextAlign == taCenter)
 drawOptions |= _FT800_CP_DRAW_OPT_CENTER;
 else if (AEveNumber->TextAlign == taCenterX)
 drawOptions |= _FT800_CP_DRAW_OPT_CENTERX;
 else if (AEveNumber->TextAlign == taCenterY)
 drawOptions |= _FT800_CP_DRAW_OPT_CENTERY;
 else if (AEveNumber->TextAlign == taRightX)
 drawOptions |= _FT800_CP_DRAW_OPT_RIGHTX;
 if (AEveNumber->Signed)
 drawOptions |= _FT800_CP_DRAW_OPT_SIGNED;
 drawOptions |= AEveNumber->Text_Length;
 FT800_Canvas_CPGraphics_DrawingOptions(drawOptions);

 FT800_Screen_NumberCP(AEveNumber->Left, AEveNumber->Top, AEveNumber->Value);
 }
}

void SetIdenticalFontSources(const code char *AFontName, unsigned long ASource) {
 char i;
 TEveText *pEveText;
 TEveNumber *pEveNumber;
 void *const code *ptrO;


 i = CurrentScreen->EveTextsCount;
 ptrO = CurrentScreen->EveTexts;
 while (i--) {
 pEveText = (TEveText *)(*ptrO);
 if (pEveText->FontName == AFontName)
 pEveText->Source = ASource;
 ptrO++;
 }


 i = CurrentScreen->EveNumbersCount;
 ptrO = CurrentScreen->EveNumbers;
 while (i--) {
 pEveNumber = (TEveNumber *)(*ptrO);
 if (pEveNumber->FontName == AFontName)
 pEveNumber->Source = ASource;
 ptrO++;
 }
}

static void ClearDynObjSource() {
 char i;
 TEveText *pEveText;
 TEveNumber *pEveNumber;
 void *const code *ptrO;


 i = CurrentScreen->EveTextsCount;
 ptrO = CurrentScreen->EveTexts;
 while (i--) {
 pEveText = (TEveText *)(*ptrO);
 pEveText->Source = 0xFFFFFFFF;
 ptrO++;
 }


 i = CurrentScreen->EveNumbersCount;
 ptrO = CurrentScreen->EveNumbers;
 while (i--) {
 pEveNumber = (TEveNumber *)(*ptrO);
 pEveNumber->Source = 0xFFFFFFFF;
 ptrO++;
 }
}

void LoadCurrentScreenResToGRAM(char loadOptions) {
 char i;
 long currSource = -1;
 long tmpDynResStart;
 TEveText *pEveText;
 TEveNumber *pEveNumber;
 void *const code *ptrO;


 if (loadOptions & VTFT_LOAD_RES_DYNAMIC)
 ClearDynObjSource();


 if (loadOptions & VTFT_LOAD_RES_DYNAMIC) {

 tmpDynResStart = CurrentScreen->DynResStart;
 if (FT800_RES_BeginLoad(tmpDynResStart)) {
 return;
 }


 i = CurrentScreen->EveTextsCount;
 ptrO = CurrentScreen->EveTexts;
 while (i--) {
 pEveText = (TEveText *)(*ptrO);
 if (pEveText->FontHandle < 16)
 if (pEveText->Source == 0xFFFFFFFF) {
 currSource = FT800_RES_LoadFont(pEveText->FontName);
 pEveText->Source = currSource;
 SetIdenticalFontSources(pEveText->FontName, currSource);
 }
 ptrO++;
 }


 i = CurrentScreen->EveNumbersCount;
 ptrO = CurrentScreen->EveNumbers;
 while (i--) {
 pEveNumber = (TEveNumber *)(*ptrO);
 if (pEveNumber->FontHandle < 16)
 if (pEveNumber->Source == 0xFFFFFFFF) {
 currSource = FT800_RES_LoadFont(pEveNumber->FontName);
 pEveNumber->Source = currSource;
 SetIdenticalFontSources(pEveNumber->FontName, currSource);
 }
 ptrO++;
 }

 FT800_RES_EndLoad();
 }
}

void DrawObject(TPointer aObj, char aObjType) {
 TDrawHandler drawHandler;

 drawHandler = DrawHandlerTable[aObjType];
 if (drawHandler)
 drawHandler(aObj);
}

void DrawScreenO(TScreen *aScreen, char aOptions) {
 unsigned short cOrder, saveOrder;
 signed int actObjOrder;
 unsigned short pwmDuty;

 char cntEveText;
 char cntEveNumber;

 TEveText *const code *pEveText;
 TEveNumber *const code *pEveNumber;


 if (aOptions & VTFT_DISPLAY_EFF_LIGHTS_FADE) {
 FT800_PWM_Get(0, &pwmDuty);
 FT800_PWM_FadeOut(pwmDuty, 0, pwmDuty/32? pwmDuty/32 : 1, 1);
 }
 else if (aOptions & VTFT_DISPLAY_EFF_LIGHTS_OFF) {
 FT800_PWM_Get(0, &pwmDuty);
 FT800_PWM_Duty(0);
 }

 if (CurrentScreen != aScreen) {

 memset(&TouchS.ActObjInfo, 0, sizeof(TObjInfo));
 }

 CurrentScreen = aScreen;

 LoadCurrentScreenResToGRAM(aOptions);


 cntEveText = CurrentScreen->EveTextsCount;
 cntEveNumber = CurrentScreen->EveNumbersCount;

 pEveText = CurrentScreen->EveTexts;
 pEveNumber = CurrentScreen->EveNumbers;

 FT800_Screen_BeginUpdateCP();
 FT800_Canvas_BrushSingleColor(_FT800_BRUSH_STYLE_SOLID, CurrentScreen->Color, 255);
 FT800_Canvas_Tag(0);
 FT800_Screen_Clear(_FT800_CLEAR_ALL);
 FT800_CP_CmdStop();

 actObjOrder = -1;
 if (TouchS.ActObjInfo.Obj)
 if (TouchS.ActObjInfo.Flags & VTFT_INT_BRING_TO_FRONT)
 actObjOrder = TouchS.ActObjInfo.Order;

 cOrder = 0;
 while (cOrder < CurrentScreen->ObjectsCount) {
 saveOrder = cOrder;
 if (pEveText) {
 while ((*pEveText)->Order == cOrder) {
 if (actObjOrder != cOrder)
 DrawEveText(*pEveText);
 cOrder++;
 pEveText++;
 cntEveText--;
 if (!cntEveText) {
 pEveText = 0;
 break;
 }
 }
 if (saveOrder != cOrder)
 continue;
 }

 if (pEveNumber) {
 while ((*pEveNumber)->Order == cOrder) {
 if (actObjOrder != cOrder)
 DrawEveNumber(*pEveNumber);
 cOrder++;
 pEveNumber++;
 cntEveNumber--;
 if (!cntEveNumber) {
 pEveNumber = 0;
 break;
 }
 }
 if (saveOrder != cOrder)
 continue;
 }

 cOrder++;
 }


 if (TouchS.ActObjInfo.Obj)
 DrawObject(TouchS.ActObjInfo.Obj, TouchS.ActObjInfo.Type);

 FT800_Screen_EndUpdate();
 FT800_Screen_Show();


 if (aOptions & VTFT_DISPLAY_EFF_LIGHTS_FADE) {
 FT800_PWM_FadeIn(0, pwmDuty, 1, 3);
 }
 else if (aOptions & VTFT_DISPLAY_EFF_LIGHTS_OFF) {
 FT800_PWM_Duty(pwmDuty);
 }

}

void DrawScreen(TScreen *aScreen) {
 if (aScreen != CurrentScreen)
 DrawScreenO(aScreen, VTFT_LOAD_RES_ALL | VTFT_DISPLAY_EFF_LIGHTS_FADE);
 else
 DrawScreenO(aScreen, VTFT_LOAD_RES_NONE);
}

char GetActiveObjectByXY(int X, int Y, TObjInfo *AObjInfo) {
 char i;
 int hiOrder;
 TEveText *pEveText;
 TEveNumber *pEveNumber;
 void *const code *ptrO;


 memset(AObjInfo, 0, sizeof(TObjInfo));



 hiOrder = -1;


 i = CurrentScreen->EveTextsCount;
 ptrO = CurrentScreen->EveTexts+CurrentScreen->EveTextsCount-1;
 while (i--) {
 pEveText = (TEveText *)(*ptrO);
 if (pEveText->Order < hiOrder)
 break;
 if (pEveText->Active) {
 if ((pEveText->Left <= X) && (pEveText->Left+pEveText->Width-1 >= X) &&
 (pEveText->Top <= Y) && (pEveText->Top+pEveText->Height-1 >= Y)) {
 AObjInfo->Obj = (void *)pEveText;
 AObjInfo->Type = VTFT_OT_EVETEXT;
 AObjInfo->Order = pEveText->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;

 hiOrder = pEveText->Order;

 break;
 }
 }
 ptrO--;
 }


 i = CurrentScreen->EveNumbersCount;
 ptrO = CurrentScreen->EveNumbers+CurrentScreen->EveNumbersCount-1;
 while (i--) {
 pEveNumber = (TEveNumber *)(*ptrO);
 if (pEveNumber->Order < hiOrder)
 break;
 if (pEveNumber->Active) {
 if ((pEveNumber->Left <= X) && (pEveNumber->Left+pEveNumber->Width-1 >= X) &&
 (pEveNumber->Top <= Y) && (pEveNumber->Top+pEveNumber->Height-1 >= Y)) {
 AObjInfo->Obj = (void *)pEveNumber;
 AObjInfo->Type = VTFT_OT_EVENUMBER;
 AObjInfo->Order = pEveNumber->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;

 hiOrder = pEveNumber->Order;

 break;
 }
 }
 ptrO--;
 }

 if (AObjInfo->Obj) {
 AObjInfo->HitX = X;
 AObjInfo->HitY = Y;
 return 1;
 }
 else {
 return 0;
 }
}

char GetActiveObjectByTag(char ATag, TObjInfo *AObjInfo) {
 char i;
 TEveText *pEveText;
 TEveNumber *pEveNumber;
 void *const code *ptrO;


 memset(AObjInfo, 0, sizeof(TObjInfo));




 i = CurrentScreen->EveTextsCount;
 ptrO = CurrentScreen->EveTexts+CurrentScreen->EveTextsCount-1;
 while (i--) {
 pEveText = (TEveText *)(*ptrO);
 if (pEveText->Tag == ATag) {
 if (pEveText->Active) {
 AObjInfo->Obj = (void *)pEveText;
 AObjInfo->Type = VTFT_OT_EVETEXT;
 AObjInfo->Order = pEveText->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;
 }
 break;
 }
 ptrO--;
 }


 i = CurrentScreen->EveNumbersCount;
 ptrO = CurrentScreen->EveNumbers+CurrentScreen->EveNumbersCount-1;
 while (i--) {
 pEveNumber = (TEveNumber *)(*ptrO);
 if (pEveNumber->Tag == ATag) {
 if (pEveNumber->Active) {
 AObjInfo->Obj = (void *)pEveNumber;
 AObjInfo->Type = VTFT_OT_EVENUMBER;
 AObjInfo->Order = pEveNumber->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;
 }
 break;
 }
 ptrO--;
 }

 if (AObjInfo->Obj) {
 AObjInfo->HitTag = ATag;
 return 1;
 }
 else {
 return 0;
 }
}

static void ProcessEvent(TEvent *pEvent) {
 if (pEvent) {
 if (pEvent->Sound.SndAct == VTFT_SNDACT_PLAY)
 FT800_Sound_SetAndPlay(pEvent->Sound.Effect, pEvent->Sound.Pitch, pEvent->Sound.Volume);
 else if (pEvent->Sound.SndAct == VTFT_SNDACT_STOP)
 FT800_Sound_Stop();
 if (pEvent->Action)
 pEvent->Action();
 }
}

static void ProcessCEvent(TCEvent *pEventC) {
 if (pEventC) {
 if (pEventC->Sound.SndAct == VTFT_SNDACT_PLAY)
 FT800_Sound_SetAndPlay(pEventC->Sound.Effect, pEventC->Sound.Pitch, pEventC->Sound.Volume);
 else if (pEventC->Sound.SndAct == VTFT_SNDACT_STOP)
 FT800_Sound_Stop();
 if (pEventC->Action)
 pEventC->Action();
 }
}

static void OnEvent(TObjInfo *AObjInfo, char AEventType){
 TEvent **ppEvent;
 TEvent *pEvent = 0;

 switch (AObjInfo->Type) {

 case VTFT_OT_EVETEXT: {
 ppEvent = &(((TEveText *)AObjInfo->Obj)->OnUp);
 pEvent = ppEvent[AEventType];
 break;
 }

 case VTFT_OT_EVENUMBER: {
 ppEvent = &(((TEveNumber *)AObjInfo->Obj)->OnUp);
 pEvent = ppEvent[AEventType];
 break;
 }
 }

 if (pEvent) {
 ProcessEvent(pEvent);
 }
}

static void Process_TP_Press() {

 if (CurrentScreen->Active)
 if ((CurrentScreen->SniffObjectEvents) || (!TouchS.ActObjInfo.Obj))
 ProcessEvent(CurrentScreen->OnPress);


 if (!TouchS.ActObjInfo.Obj)
 return;

 OnEvent(&TouchS.ActObjInfo, VTFT_EVT_PRESS);
}

static void Process_TP_Up() {
 char isClick;
 TObjInfo actObj;


 if (CurrentScreen->Active)
 if ((CurrentScreen->SniffObjectEvents) || (!TouchS.ActObjInfo.Obj))
 ProcessEvent(CurrentScreen->OnUp);

 actObj = TouchS.ActObjInfo;

 memset(&TouchS.ActObjInfo, 0, sizeof(TObjInfo));


 if (!actObj.Obj)
 return;

 isClick = IsInsideObject(&actObj, TouchS.X, TouchS.Y);

 if (actObj.Flags & VTFT_INT_REPAINT_ON_UP)
 DrawScreen(CurrentScreen);

 OnEvent(&actObj, VTFT_EVT_UP);
 if (isClick)
 OnEvent(&actObj, VTFT_EVT_CLICK);
}

static void Process_TP_Down() {

 if (TouchS.Tag) {
 if (TouchS.Tag != 255)
 GetActiveObjectByTag(TouchS.Tag, &TouchS.ActObjInfo);
 if (!TouchS.ActObjInfo.Obj)
 GetActiveObjectByXY(TouchS.X, TouchS.Y, &TouchS.ActObjInfo);
 }


 if (CurrentScreen->Active)
 if ((CurrentScreen->SniffObjectEvents) || (!TouchS.ActObjInfo.Obj))
 ProcessEvent(CurrentScreen->OnDown);


 if (!TouchS.ActObjInfo.Obj)
 return;

 if (TouchS.ActObjInfo.Flags & VTFT_INT_REPAINT_ON_DOWN)
 DrawScreen(CurrentScreen);

 OnEvent(&TouchS.ActObjInfo, VTFT_EVT_DOWN);
}

static void Process_TP_TagChange() {

 if (CurrentScreen->Active)
 ProcessEvent(CurrentScreen->OnTagChange);
}

void ProcessVTFTStack() {
 char Tag, oldTag;
 unsigned int X, Y;

 oldTag = TouchS.Tag;

 if (FT800_Touch_GetTagXY(&X, &Y) == 1) {
 FT800_Touch_GetTag(&Tag);

 TouchS.Tag = Tag;
 TouchS.X = X;
 TouchS.Y = Y;

 if (!TouchS.Pressed) {
 TouchS.Pressed = 1;
 Process_TP_Down();
 }

 Process_TP_Press();
 }
 else if (TouchS.Pressed) {
 Process_TP_Up();

 TouchS.Tag = 0;
 TouchS.X = X;
 TouchS.Y = Y;

 TouchS.Pressed = 0;
 }

 if (oldTag != TouchS.Tag)
 Process_TP_TagChange();
}

static void InitObjects() {

 Screen1.Color = 0x9800;
 Screen1.Width = 480;
 Screen1.Height = 272;
 Screen1.ObjectsCount = 2;
 Screen1.EveTextsCount = 1;
 Screen1.EveTexts = Screen1_EveTexts;
 Screen1.EveNumbersCount = 1;
 Screen1.EveNumbers = Screen1_EveNumbers;
 Screen1.DynResStart = 0;
 Screen1.Active = 1;
 Screen1.SniffObjectEvents = 0;
 Screen1.OnUp = 0;
 Screen1.OnDown = 0;
 Screen1.OnTagChange = 0;
 Screen1.OnPress = 0;

 EveText1.OwnerScreen = &Screen1;
 EveText1.Order = 0;
 EveText1.Visible = 1;
 EveText1.Opacity = 255;
 EveText1.Tag = 255;
 EveText1.Left = 115;
 EveText1.Top = 50;
 EveText1.Width = 215;
 EveText1.Height = 53;
 EveText1.Caption = EveText1_Caption;
 EveText1.TextAlign = taNone;
 EveText1.FontName = Tahoma_48x48_BoldItalic;
 EveText1.Font_Color = 0xFFFF;
 EveText1.FontHandle = 1;
 EveText1.Source = -1UL;
 EveText1.Active = 1;
 EveText1.OnUp = 0;
 EveText1.OnDown = 0;
 EveText1.OnClick = 0;
 EveText1.OnPress = 0;

 EveNumber1.OwnerScreen = &Screen1;
 EveNumber1.Order = 1;
 EveNumber1.Visible = 1;
 EveNumber1.Opacity = 255;
 EveNumber1.Tag = 255;
 EveNumber1.Left = 200;
 EveNumber1.Top = 140;
 EveNumber1.Width = 40;
 EveNumber1.Height = 53;
 EveNumber1.Text_Length = 0;
 EveNumber1.TextAlign = taNone;
 EveNumber1.FontName = Tahoma_48x48_BoldItalic;
 EveNumber1.Font_Color = 0xFFFF;
 EveNumber1.FontHandle = 1;
 EveNumber1.Source = -1UL;
 EveNumber1.Value = 0;
 EveNumber1.Signed = 0;
 EveNumber1.Active = 1;
 EveNumber1.OnUp = 0;
 EveNumber1.OnDown = 0;
 EveNumber1.OnClick = 0;
 EveNumber1.OnPress = 0;

}

void Init_MCU(){
 SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4, _SPI_DATA_SAMPLE_MIDDLE,
 _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
}

void InitVTFTStack() {
 union {
 TFT800PWM PWM;
 TFT800GPIO GPIO;
 TFT800Audio Audio;
 TFT800Sound Sound;
 TFT800Touch Touch;
 TFT800Display Display;
 TFT800Interrupt Interrupt;
 TFT800TouchTransform TTransform;
 } cfg;

 Init_MCU();

 SPI_Set_Active(&SPI1_Read, &SPI1_Write);


 InitObjects();


 FT800_Init();

 FT800_Core_ClockSource(_FT800_CLK_SOURCE_EXTERNAL);
 FT800_Core_ClockPLL(_FT800_CLK_PLL_48MHz);


 cfg.Display = VTFT_FT800_CONFIG_DISPLAY;
 FT800_Display_SetConfig(&cfg.Display);

 cfg.Audio = VTFT_FT800_CONFIG_AUDIO;
 FT800_Audio_SetConfig(&cfg.Audio);

 cfg.Sound = VTFT_FT800_CONFIG_SOUND;
 FT800_Sound_SetConfig(&cfg.Sound);

 cfg.Interrupt = VTFT_FT800_CONFIG_INTERRUPT;
 FT800_Interrupt_SetConfig(&cfg.Interrupt);

 cfg.PWM = VTFT_FT800_CONFIG_PWM;
 FT800_PWM_SetConfig(&cfg.PWM);

 cfg.GPIO = VTFT_FT800_CONFIG_GPIO;
 FT800_GPIO_SetConfig(&cfg.GPIO);

 cfg.Touch = VTFT_FT800_CONFIG_TOUCH;
 FT800_Touch_SetConfig(&cfg.Touch);

 cfg.TTransform = VTFT_FT800_CONFIG_TOUCHTRANSFORM;
 FT800_TouchTransform_SetConfig(&cfg.TTransform);


 DrawScreen(&Screen1);
}
